/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3) 
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details. 
 */

package org.dive4elements.river.client.server;

import java.io.InputStream;

import java.util.Map;
import java.util.HashMap;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;

import org.apache.log4j.Logger;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import org.dive4elements.artifacts.common.utils.XMLUtils;

import org.dive4elements.river.client.shared.exceptions.ServerException;
import org.dive4elements.river.client.client.services.MapUrlService;


public class MapUrlServiceImpl
extends      RemoteServiceServlet
implements   MapUrlService
{

    private static final Logger logger =
        Logger.getLogger(MapUrlServiceImpl.class);


    public Map<String, String> getUrls()
    throws ServerException
    {
        logger.info("MapUrlServiceImpl.getUrls");
        Map<String, String> urls = new HashMap<String, String>();

        InputStream in = getServletContext().getResourceAsStream("/WEB-INF/wms-services.xml");

        Document doc = XMLUtils.parseDocument(in);

        NodeList list = doc.getElementsByTagName("wms");
        for (int i = 0; i < list.getLength(); i++) {
            Element e = (Element) list.item(i);
            urls.put(e.getAttribute("url"), e.getAttribute("name"));
        }

        return urls;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
